<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Scandoc;

/**
 * ScandocSearch represents the model behind the search form about `app\models\Scandoc`.
 */
class ScandocSearch extends Scandoc
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['scandocid', 'create_time', 'create_user', 'update_time', 'update_user', 'record_date'], 'integer'],
            [['artccode', 'artcname', 'scandocname', 'status'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Scandoc::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'scandocid' => $this->scandocid,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
            'record_date' => $this->record_date,
        ]);

        $query->andFilterWhere(['like', 'artccode', $this->artccode])
            ->andFilterWhere(['like', 'artcname', $this->artcname])            
            ->andFilterWhere(['like', 'scandocname', $this->scandocname])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
